#include <windows.h>
#include "resource.h"
#include <stdio.h>

#include "WUSBdrv.h"

DWORD WINAPI WriteRoutine(void* param);

int ByteCounter;
bool Terminate;
//***************************************************


LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR szCmdLine, int iCmdShow)
{
 	char szAppName[]="MyProc";
	HWND hwnd;
	MSG msg;

	WNDCLASSEX wndclass;

	wndclass.cbSize = sizeof(WNDCLASSEX); 
	wndclass.style			= CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc	= WndProc;	
	wndclass.hInstance		= hInstance;
	wndclass.lpszClassName	= szAppName;
	wndclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hIconSm		= LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName	= (LPCSTR)IDR_MENU1;	
	wndclass.cbClsExtra		= 0;
	wndclass.cbWndExtra		= 0;

	RegisterClassEx(&wndclass);


	hwnd = CreateWindow(szAppName, "Test WUSB", WS_OVERLAPPEDWINDOW,
      100, 100, 300, 200, NULL, NULL, hInstance, NULL);

	ShowWindow(hwnd, iCmdShow);
	UpdateWindow(hwnd);


	while (GetMessage(&msg, NULL, 0, 0)) 
	{		
			TranslateMessage(&msg);
			DispatchMessage(&msg);		
	}

	return msg.wParam;
}


LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;
	int wmId, wmEvent;

	switch (message) 
	{	
		case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 			
		switch (wmId)
		{
			case ID_OPEN:	
			{
				//***************************************************
				//******************** WUSB *************************

				int status = WUSB_Open();
				if(status == WUSB_ERROR)
				{		
					MessageBox(NULL, "ERROR! Can`t open WodmanUSB device", "Info", MB_ICONERROR);		
				}
				else
				{
					MessageBox(NULL, "Open OK", "Info", MB_ICONINFORMATION);		
				}
			
				//***************************************************
				break;
			}
			case ID_START:	
			{
				//***************************************************
				//******************** WUSB *************************
				HANDLE hThread;
				DWORD dwIDThread;

				ByteCounter = 0;
				Terminate = false;
				hThread = CreateThread(NULL, 0, WriteRoutine, NULL, 0, &dwIDThread);

			
				//***************************************************
				break;
			}
			case ID_STOP:	
			{
				//***************************************************
				//******************** WUSB *************************

				Terminate = true;
				char str[20];
				sprintf(str, "Write: %d byte", ByteCounter);
				MessageBox(NULL, str, "Info", MB_ICONINFORMATION);
					

				//***************************************************	
				break;
			}
			
		}
		break;

		case WM_PAINT:	
		{
			hdc=BeginPaint(hwnd, &ps);
			
			EndPaint(hwnd, &ps);
			break;
		}

		case WM_DESTROY:
		{
				PostQuitMessage(0);
				break;		
		}
   }
   
	return DefWindowProc(hwnd, message, wParam, lParam);
}


//***************************************************
//******************** WUSB *************************

DWORD WINAPI WriteRoutine(void* param)
{
	WUSB_SetupPortB(ASYNC_MODE); 
	
	
	char buf[256]; 	
	for(int i = 0; i < sizeof(buf); i++)
	{
		buf[i] = i;
	}

	unsigned int dwWrite;
	int status;


	while(!Terminate)
	{
		status = WUSB_WritePortB(buf, sizeof(buf), &dwWrite);
		if(status == WUSB_ERROR)
		{
			MessageBox(NULL, "Write Error!", "", MB_ICONERROR);
			break;
		} 
		else if(status == WUSB_TIMEOUT)
		{
			MessageBox(NULL, "TIMEOUT", "", MB_ICONERROR);
			break;
		}

		ByteCounter += dwWrite;
	}

	return 0;
}


//***************************************************