///////////////////////////////////////////////////////////////////////////
//
//Copyright (c) 2006-2013  KERNELCHIP 
//
//Module Name:
//    WUSBdrv.h
//
//Abstract:
//    Function defenitions for WoodmanUSB device	
//
///////////////////////////////////////////////////////////////////////////

typedef HANDLE WUSB_HANDLE;


#define ASYNC_MODE			0x1D
#define SYNC_MODE_EXTERNAL_CLK		0x0C
#define SYNC_MODE_INTERNAL_CLK_30MHZ	0x14
#define SYNC_MODE_INTERNAL_CLK_48MHZ	0x1C
#define SYNC_MODE_EXTERNAL_CLK		0x0C

#define WUSB_ERROR		0
#define WUSB_OK			1
#define WUSB_TIMEOUT		2


#define FIFO_EMPTY		0
#define FIFO_FULL		1
#define FIFO_NOTEMPTY		2


#define WUSB_API extern "C" __declspec(dllexport)

WUSB_API int WUSB_Open();

WUSB_API int WUSB_SetupPortA(unsigned char iomsk);
WUSB_API int WUSB_SetupPortB(unsigned char params);
WUSB_API int WUSB_WritePortA(unsigned char value);
WUSB_API int WUSB_ReadPortA(unsigned char* data);

WUSB_API int WUSB_WritePortB(char *buf, unsigned int bufsize, unsigned int* dwWrite);
WUSB_API int WUSB_ReadPortB(char *buf, unsigned int bufsize,  unsigned int* dwRead);
WUSB_API int WUSB_RawWritePortB(char *buf, unsigned int bufsize, unsigned int* dwWrite);
WUSB_API int WUSB_RawReadPortB(char *buf, unsigned int bufsize,  unsigned int* dwRead);

WUSB_API int WUSB_GetFIFOStatus(unsigned char* INstatus, unsigned char* OUTstatus);
WUSB_API int WUSB_SetTimeOuts(unsigned int ReadTimeOut, unsigned int WriteTimeOut);
WUSB_API int WUSB_GetTimeOuts(unsigned int* ReadTimeOut, unsigned int* WriteTimeOut);

WUSB_API bool WUSB_AbortWritePortB();
WUSB_API bool WUSB_AbortReadPortB();

WUSB_API int WUSB_Close();





